import Ember from 'ember';
import TetherDialog from 'ember-modal-dialog/components/deprecated-tether-dialog';

const isIOS = /iPad|iPhone|iPod/.test(navigator.userAgent);

export default TetherDialog.extend({

  // same as super function in ModalDialog, except for the clickOutSideToCloseException handling
  didInsertElement() {
    if (!this.get('clickOutsideToClose')) {
      return;
    }

    const handleClick = (event) => {
      const exception = this.get('clickOutSideToCloseException');
      const eventTarget = $(event.target);
      const notClickedOnDialog = !eventTarget.closest('.ember-modal-dialog').length;
      const notClickedOnException = !exception || !eventTarget.closest(exception).length;
      if (notClickedOnDialog && notClickedOnException) {
        this.sendAction('onClose');
      }
    };
    const registerClick = () => $(document).on(`click.ember-modal-dialog-${Ember.guidFor(this)}`, handleClick);

    // setTimeout needed or else the click handler will catch the click that spawned this modal dialog
    setTimeout(registerClick);

    if (isIOS) {
      const registerTouch = () => $(document).on(`touchend.ember-modal-dialog-${Ember.guidFor(this)}`, handleClick);
      setTimeout(registerTouch);
    }
  },

});
